// DesignerViewStateViewport.h : Declaration of the CDesignerViewStateViewport

#pragma once
#include "resource.h"       // main symbols
#include "RWConceptViewport.h"


// CDesignerViewStateViewport

class ATL_NO_VTABLE CDesignerViewStateViewport : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CDesignerViewStateViewport, &CLSID_DesignerViewStateViewport>,
	public ISharedState,
	public ISharedStateViewport
{
public:
	CDesignerViewStateViewport() : m_nSizeX(1), m_nSizeY(1),
		m_tProj(TMATRIX4X4F_IDENTITY), m_tView(TMATRIX4X4F_IDENTITY),
		m_nPointLights(0), m_aPointLights(NULL),
		m_nDirectionalLights(0), m_aDirectionalLights(NULL)
	{
	}
	~CDesignerViewStateViewport()
	{
		delete[] m_aPointLights;
		delete[] m_aDirectionalLights;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_DESIGNERVIEWSTATEVIEWPORT)


BEGIN_COM_MAP(CDesignerViewStateViewport)
	COM_INTERFACE_ENTRY(ISharedState)
	COM_INTERFACE_ENTRY(ISharedStateViewport)
END_COM_MAP()


	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
	}

	// ISharedState methods
public:
	STDMETHOD(CLSIDGet)(CLSID* a_pCLSID);
	STDMETHOD(ToText)(BSTR* a_pbstrText);
	STDMETHOD(FromText)(BSTR a_bstrText);

	// ISharedStateViewport methods
public:
	STDMETHOD(Init)(ULONG a_nSizeX, ULONG a_nSizeY, TMatrix4x4f const* a_pProjection, TMatrix4x4f const* a_pView, ULONG a_nPointLights, TPointLight const* a_aPointLights, ULONG a_nDirectionalLights, TDirectionalLight const* a_aDirectionalLights);
	STDMETHOD(CameraGet)(TMatrix4x4f* a_pProjection, TMatrix4x4f* a_pView);
	STDMETHOD(LightsGet)(IEnumStructs** a_ppPointLights, IEnumStructs** a_ppDirectionalLights);
	STDMETHOD(WindowGet)(ULONG* a_pnSizeX, ULONG* a_pnSizeY);

private:
	ULONG m_nSizeX;
	ULONG m_nSizeY;
	TMatrix4x4f m_tProj;
	TMatrix4x4f m_tView;
	ULONG m_nPointLights;
	TPointLight* m_aPointLights;
	ULONG m_nDirectionalLights;
	TDirectionalLight* m_aDirectionalLights;
};

OBJECT_ENTRY_AUTO(__uuidof(DesignerViewStateViewport), CDesignerViewStateViewport)
