// DesignerViewFactoryFileBrowser.h : Declaration of the CDesignerViewFactoryFileBrowser

#pragma once
#include "resource.h"       // main symbols

#include "RWDesignerServices.h"
#include <WeakSingleton.h>


#if defined(_WIN32_WCE) && !defined(_CE_DCOM) && !defined(_CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA)
#error "Single-threaded COM objects are not properly supported on Windows CE platform, such as the Windows Mobile platforms that do not include full DCOM support. Define _CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA to force ATL to support creating single-thread COM object's and allow use of it's single-threaded COM object implementations. The threading model in your rgs file was set to 'Free' as that is the only threading model supported in non DCOM Windows CE platforms."
#endif



// CDesignerViewFactoryFileBrowser

class ATL_NO_VTABLE CDesignerViewFactoryFileBrowser :
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CDesignerViewFactoryFileBrowser, &CLSID_DesignerViewFactoryFileBrowser>,
	public IDesignerViewFactory,
	public IDocumentMenuCommands
{
public:
	CDesignerViewFactoryFileBrowser()
	{
	}

DECLARE_NO_REGISTRY()
DECLARE_CLASSFACTORY_WEAKSINGLETON(CDesignerViewFactoryFileBrowser)

BEGIN_CATEGORY_MAP(CDesignerViewFactoryFileBrowser)
	IMPLEMENTED_CATEGORY(CATID_DesignerViewFactory)
	IMPLEMENTED_CATEGORY(CATID_DocumentMenuCommands)
END_CATEGORY_MAP()

BEGIN_COM_MAP(CDesignerViewFactoryFileBrowser)
	COM_INTERFACE_ENTRY(IDesignerViewFactory)
	COM_INTERFACE_ENTRY(IDocumentMenuCommands)
END_COM_MAP()


	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}

	void FinalRelease()
	{
	}

	// IDesignerViewFactory methods
public:
	STDMETHOD(NameGet)(IViewManager* a_pManager, ILocalizedString** a_ppOperationName);
	STDMETHOD(ConfigCreate)(IViewManager* a_pManager, IConfig** a_ppDefaultConfig);
	STDMETHOD(CreateWnd)(IViewManager* a_pManager, IConfig* a_pConfig, ISharedStateManager* a_pFrame, IStatusBarObserver* a_pStatusBar, IDocument* a_pDoc, RWHWND a_hParent, RECT const* a_prcWindow, EDesignerViewWndStyle a_nStyle, LCID a_tLocaleID, IDesignerView** a_ppDVWnd);
	STDMETHOD(CheckSuitability)(IViewManager* a_pManager, IConfig* a_pConfig, IDocument* a_pDocument, ICheckSuitabilityCallback* a_pCallback);

	// IDocumentMenuCommands methods
public:
	STDMETHOD(NameGet)(IMenuCommandsManager* a_pManager, ILocalizedString** a_ppOperationName);
	STDMETHOD(ConfigCreate)(IMenuCommandsManager* a_pManager, IConfig** a_ppDefaultConfig);
	STDMETHOD(CommandsEnum)(IMenuCommandsManager* a_pManager, IConfig* a_pConfig, IOperationContext* a_pContext, IDesignerView* a_pView, IDocument* a_pDocument, IEnumUnknowns** a_ppSubCommands);

	GUID GetIconID(CComBSTR const& a_bstrFilterID)
	{
		ObjectLock cLock(this);
		std::map<CComBSTR, GUID>::const_iterator i = m_cIconIDs.find(a_bstrFilterID);
		if (i == m_cIconIDs.end())
		{
			GUID t;
			CoCreateGuid(&t);
			m_cIconIDs[a_bstrFilterID] = t;
			return t;
		}
		return i->second;
	}

private:
	std::map<CComBSTR, GUID> m_cIconIDs;
};

OBJECT_ENTRY_AUTO(__uuidof(DesignerViewFactoryFileBrowser), CDesignerViewFactoryFileBrowser)
