// DocumentOperationSave.h : Declaration of the CDocumentOperationSave

#pragma once
#include "resource.h"       // main symbols
#include "RWDesignerServices.h"
#include <WeakSingleton.h>
#include <RWProcessingTags.h>


// CDocumentOperationSave

class ATL_NO_VTABLE CDocumentOperationSave : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CDocumentOperationSave, &CLSID_DocumentOperationSave>,
	public IDocumentOperation
{
public:
	CDocumentOperationSave()
	{
	}

DECLARE_NO_REGISTRY()
DECLARE_CLASSFACTORY_WEAKSINGLETON(CDocumentOperationSave)

BEGIN_CATEGORY_MAP(CDocumentOperationSave)
	IMPLEMENTED_CATEGORY(CATID_DocumentOperation)
	IMPLEMENTED_CATEGORY(CATID_TagInteractive)
END_CATEGORY_MAP()

BEGIN_COM_MAP(CDocumentOperationSave)
	COM_INTERFACE_ENTRY(IDocumentOperation)
END_COM_MAP()


	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
	}

	// IDocumentOperation methods
public:
	STDMETHOD(NameGet)(IOperationManager* a_pManager, ILocalizedString** a_ppOperationName);
	STDMETHOD(ConfigCreate)(IOperationManager* a_pManager, IConfig** a_ppDefaultConfig);
	STDMETHOD(CanActivate)(IOperationManager* a_pManager, IDocument* a_pDocument, IConfig* a_pConfig, IOperationContext* a_pStates);
	STDMETHOD(Activate)(IOperationManager* a_pManager, IDocument* a_pDocument, IConfig* a_pConfig, IOperationContext* a_pStates, RWHWND a_hParent, LCID a_tLocaleID);

private:
	CComPtr<IStorageManager> m_pStorageMgr;
};

OBJECT_ENTRY_AUTO(__uuidof(DocumentOperationSave), CDocumentOperationSave)
