#pragma once

#include "resource.h"
#include "RWDesignerServices.h"
#include <Win32LangEx.h>
#include <ContextHelpDlg.h>


class CShellAssociationsDlg :
	public Win32LangEx::CLangDialogImpl<CShellAssociationsDlg>,
	public CDialogResize<CShellAssociationsDlg>,
	public CContextHelpDlg<CShellAssociationsDlg>
{
public:
	CShellAssociationsDlg(LCID a_tLocaleID, HICON a_hIcon);
	~CShellAssociationsDlg();

	enum
	{
		IDD = IDD_SHELLASSOCIATIONS,
	};

	BEGIN_MSG_MAP(CShellAssociationsDlg)
		CHAIN_MSG_MAP(CContextHelpDlg<CShellAssociationsDlg>)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
		COMMAND_ID_HANDLER(IDOK, OnOK)
		COMMAND_ID_HANDLER(IDCANCEL, OnCancel)
		CHAIN_MSG_MAP(CDialogResize<CShellAssociationsDlg>)
	END_MSG_MAP()

	BEGIN_DLGRESIZE_MAP(CShellAssociationsDlg)
		DLGRESIZE_CONTROL(IDOK, DLSZ_MOVE_X | DLSZ_MOVE_Y)
		DLGRESIZE_CONTROL(IDCANCEL, DLSZ_MOVE_X | DLSZ_MOVE_Y)
		DLGRESIZE_CONTROL(IDHELP, DLSZ_MOVE_Y)
		DLGRESIZE_CONTROL(IDC_SHLASSOC_LIST, DLSZ_SIZE_X | DLSZ_SIZE_Y)
	END_DLGRESIZE_MAP()

	BEGIN_CTXHELP_MAP(CAppOptionsDlg)
		CTXHELP_CONTROL_RESOURCE(IDOK, IDS_HELP_IDOK)
		CTXHELP_CONTROL_RESOURCE(IDCANCEL, IDS_HELP_IDCANCEL)
		CTXHELP_CONTROL_RESOURCE(IDHELP, IDS_HELP_IDHELP)
		CTXHELP_CONTROL_RESOURCE(IDC_SHLASSOC_LIST, IDS_HELP_SHLASSOC_LIST)
	END_CTXHELP_MAP()

protected:
	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnDestroy(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnCancel(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnOK(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);

private:
	HRESULT DeleteSubTree(HKEY a_hRootKey);

private:
	HICON m_hIcon;
	CComPtr<IInputManager> m_pInMgr;
	CListViewCtrl m_wndList;
};
