// DocumentDecoderRLI.h : Declaration of the CDocumentDecoderRLI

#pragma once
#include "resource.h"       // main symbols

#include "RWCodecImageRealWorld_i.h"


#if defined(_WIN32_WCE) && !defined(_CE_DCOM) && !defined(_CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA)
#error "Single-threaded COM objects are not properly supported on Windows CE platform, such as the Windows Mobile platforms that do not include full DCOM support. Define _CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA to force ATL to support creating single-thread COM object's and allow use of it's single-threaded COM object implementations. The threading model in your rgs file was set to 'Free' as that is the only threading model supported in non DCOM Windows CE platforms."
#endif

#include "DocumentEncoderRLI.h"


// CDocumentDecoderRLI

class ATL_NO_VTABLE CDocumentDecoderRLI :
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CDocumentDecoderRLI, &CLSID_DocumentDecoderRLI>,
	public IDocumentDecoder
{
public:
	CDocumentDecoderRLI()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_DOCUMENTDECODERRLI)
DECLARE_CLASSFACTORY_SINGLETON(CDocumentDecoderRLI)

BEGIN_CATEGORY_MAP(CDocumentDecoderRLI)
	IMPLEMENTED_CATEGORY(CATID_DocumentDecoder)
END_CATEGORY_MAP()

BEGIN_COM_MAP(CDocumentDecoderRLI)
	COM_INTERFACE_ENTRY(IDocumentDecoder)
END_COM_MAP()



	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}

	void FinalRelease()
	{
	}

	// IDocumentDecoder methods
public:
	STDMETHOD(Priority)(ULONG* a_pnPriority);
	STDMETHOD(DocumentType)(IDocumentType** a_ppDocumentType);
	STDMETHOD(IsCompatible)(ULONG a_nBuilders, IDocumentBuilder* const* a_apBuilders);
	STDMETHOD(Parse)(ULONG a_nLen, BYTE const* a_pData, IStorageFilter* a_pLocation, ULONG a_nBuilders, IDocumentBuilder* const* a_apBuilders, BSTR a_bstrPrefix, IDocumentBase* a_pBase, GUID* a_pEncoderID, IConfig** a_ppEncoderCfg, ITaskControl* a_pControl);

};

OBJECT_ENTRY_AUTO(__uuidof(DocumentDecoderRLI), CDocumentDecoderRLI)
