
#pragma once
#include <RWBaseEnumUtils.h>

class CSubDocCreatorRasterImage :
	public CStackUnknown<IIconImageCreator>
{
public:
	CSubDocCreatorRasterImage(TImageSize const& a_tSize, TPixelChannel const* a_pPixels) :
		m_tSize(a_tSize), m_pPixels(a_pPixels)
	{
	}

	// IImageLayerCreator methods
public:
	STDMETHOD(Create)(IDocumentBuilder* a_pBuilder, BSTR a_bstrID, IDocumentBase* a_pBase)
	{
		CComQIPtr<IDocumentFactoryRasterImage> pFct(a_pBuilder);
		return pFct->Create(a_bstrID, a_pBase, &m_tSize, NULL, 1, CChannelDefault(EICIRGBA, 0, 0, 0, 0), 2.2f, m_pPixels ? CImageTile(m_tSize.nX, m_tSize.nY, m_pPixels).operator const TImageTile *() : NULL);
	}

private:
	TImageSize m_tSize;
	TPixelChannel const* m_pPixels;
};

class CIconImageCreatorDocCopy :
	public CStackUnknown<IIconImageCreator>
{
public:
	CIconImageCreatorDocCopy(IDocument* a_pDoc) : m_pDoc(a_pDoc)
	{
	}

	// IIconImageCreator methods
public:
	STDMETHOD(Create)(IDocumentBuilder* a_pDefaultBuilder, BSTR a_bstrID, IDocumentBase* a_pBase)
	{
		return m_pDoc->DocumentCopy(a_bstrID, a_pBase, NULL, NULL);
	}

private:
	IDocument* m_pDoc;
};