#pragma once

class CDrawCache
{
public:
	CDrawCache()
	{
	}

	~CDrawCache()
	{
		ATriplets::const_iterator i;
		for (i = m_aTriplets.begin(); i != m_aTriplets.end(); i++)
		{
			const STriplet& STriplet = *i;
			if (STriplet.pPSrc) STriplet.pPSrc->Release();
			if (STriplet.pVSrc) STriplet.pVSrc->Release();
			if (STriplet.pGSrc) STriplet.pGSrc->Release();
		}
	}

	HRESULT Render(IOutputSink* a_pSink) const
	{
		ATriplets::const_iterator i;
		for (i = m_aTriplets.begin(); i != m_aTriplets.end(); i++)
		{
			const STriplet& STriplet = *i;
			a_pSink->DrawSegment(STriplet.pPSrc, STriplet.pVSrc, STriplet.pGSrc);
		}

		return S_OK;
	}

	void InsertItem(IPixelProcSource* a_pPSrc, IVertexProcSource* a_pVSrc, IGeometrySource* a_pGSrc)
	{
		if (a_pGSrc == NULL)
			return;

		STriplet STriplet;
		(STriplet.pGSrc = a_pGSrc)->AddRef();
		if ((STriplet.pPSrc = a_pPSrc) != NULL) a_pPSrc->AddRef();
		if ((STriplet.pVSrc = a_pVSrc) != NULL) a_pVSrc->AddRef();

		m_aTriplets.push_back(STriplet);
	}

private:
	struct STriplet
	{
		IPixelProcSource* pPSrc;
		IVertexProcSource* pVSrc;
		IGeometrySource* pGSrc;
	};
	typedef vector<STriplet> ATriplets;

	ATriplets m_aTriplets;
};
