
#pragma once


inline void InitializeDefaults(IConfig* a_pCfg)
{
	CComPtr<IConfig> pC1;
	a_pCfg->SubConfigGet(CComBSTR(L"Layouts"), &pC1);
	CComQIPtr<IConfigInRegistry> pCIR1(pC1);
	if (pCIR1)
		pCIR1->ItemValuesDeleteAll();
	CComPtr<IConfig> pC2;
	a_pCfg->SubConfigGet(CComBSTR(L"Operations"), &pC2);
	CComQIPtr<IConfigInRegistry> pCIR2(pC2);
	if (pCIR2)
		pCIR2->ItemValuesDeleteAll();

	HRSRC hLayouts = FindResource(hInst, MAKEINTRESOURCE(IDR_DEFAULTS), _T("RT_CONFIG"));
	HGLOBAL hMem = LoadResource(hInst, hLayouts);
	DWORD nMemSize = SizeofResource(hInst, hLayouts);
	CComPtr<IConfigInMemory> pMemCfg;
	RWCoCreateInstance(pMemCfg, __uuidof(ConfigInMemory));
	pMemCfg->DataBlockSet(nMemSize, static_cast<BYTE const*>(LockResource(hMem)));
	CopyConfigValues(a_pCfg, pMemCfg);
}
