// RWDesigner.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"

#define RWAPPID L"RWPaint"
#define APP_MSGBOX_CAPTION _T("RealWorld Paint")
#define HOMEPAGE_LINK(langid) langid == MAKELANGID(LANG_CZECH, SUBLANG_DEFAULT) ? _T("http://www.rw-designer.com/image-editor-cz") : _T("http://www.rw-designer.com/image-editor")
#define DONATE_LINK(langid) langid== MAKELANGID(LANG_CZECH, SUBLANG_DEFAULT) ? _T("http://www.rw-designer.com/paint-donate-cz") : _T("http://www.rw-designer.com/paint-donate")

#include <RWDesignerCore.h>
#include <RWLocalization.h>
#include <shlobj.h>
#include <XPGUI.h>
#include <MD5.h>
#include <RWCOMImpl.inl>


// Global Variables:
HINSTANCE hInst;								// current instance

#include <CommCtrlDependency.h>
#include <Win32LangEx.h>
#include <StringParsing.h>
#include <ContextHelpDlg.h>
#define AFX_RESOURCE_DLL
#include <RWVersionInfo.rc2>
#include <MultiLanguageString.h>

HRESULT AppLicenseBox(RWHWND a_hWndParent, LCID a_tLocaleID, IApplicationInfo* a_pAI)
{
	::ShellExecute(0, _T("open"), DONATE_LINK(a_tLocaleID), 0, 0, SW_SHOWNORMAL);
	return S_OK;
}

#include <RWSplash.inl>

class CAboutDlg : 
	public Win32LangEx::CLangIndirectDialogImpl<CAboutDlg>,
	public CContextHelpDlg<CAboutDlg>
{
public:
	CAboutDlg(LCID a_tLocaleID, IApplicationInfo* a_pApplicationInfo) :
		Win32LangEx::CLangIndirectDialogImpl<CAboutDlg>(a_tLocaleID),
		CContextHelpDlg<CAboutDlg>(_T("Copyright.html")),
		m_hBrush(::CreateSolidBrush(0xffffff)),
		m_pApplicationInfo(a_pApplicationInfo)
	{
	}
	~CAboutDlg()
	{
		::DeleteObject(m_hBrush);
	}

	enum
	{
		IDC_NAMEANDVERSION = 100,
		IDC_COPYRIGHTS,
		IDC_HOMEPAGELINK,
		IDC_LICENSE,
		IDC_DONATE,
		IDC_CUSTOMIZE,
	};

	BEGIN_DIALOG_EX(0, 0, 282, 166, 0)
		DIALOG_FONT_AUTO()
		DIALOG_STYLE(WS_POPUP|WS_CAPTION|WS_SYSMENU|DS_MODALFRAME|WS_CLIPCHILDREN|WS_CLIPSIBLINGS)
		DIALOG_EXSTYLE(WS_EX_CONTEXTHELP|WS_EX_CONTROLPARENT)
		DIALOG_CAPTION(_T("[0409]About ") APP_MSGBOX_CAPTION _T("[0405]O aplikaci ") APP_MSGBOX_CAPTION)
	END_DIALOG()

	BEGIN_CONTROLS_MAP()
		CONTROL_DEFPUSHBUTTON(_T("[0409]OK[0405]OK"), IDOK, 225, 145, 50, 14, WS_VISIBLE, 0)
		CONTROL_CONTROL(IDB_ABOUT, IDC_STATIC, WC_STATIC, SS_BITMAP | SS_CENTERIMAGE | SS_REALSIZEIMAGE | WS_VISIBLE, 6, 7, 127, 152, 0)
		CONTROL_LTEXT(_T("[0000]") APP_MSGBOX_CAPTION _T(" ") _T(RWVER0409_PRODUCTVERSION), IDC_NAMEANDVERSION, 141, 7, 134, 8, WS_VISIBLE, 0)
		CONTROL_LTEXT(_T("[0409]Application web page.[0405]Webov strnka aplikace."), IDC_HOMEPAGELINK, 141, 19, 101, 8, WS_VISIBLE, 0)
		CONTROL_LTEXT(_T("[0000]Copyright  2016"), IDC_STATIC, 141, 31, 117, 8, WS_VISIBLE, 0)
		CONTROL_LTEXT(_T("[0000]Vlastimil Mil, Jan Mil"), IDC_STATIC, 150, 41, 125, 8, WS_VISIBLE, 0)
		CONTROL_PUSHBUTTON(_T("[0409]More about authors and license[0405]Vce o autorech a licenci"), IDC_COPYRIGHTS, 150, 53, 125, 14, WS_VISIBLE, 0)
		CONTROL_CONTROL(_T(""), IDC_STATIC, WC_STATIC, SS_ETCHEDHORZ | WS_VISIBLE, 141, 72, 134, 1, 0)
		CONTROL_LTEXT(_T("[0409]Send a donation.[0405]Poslat pspvek."), IDC_DONATE, 141, 121, 80, 8, WS_VISIBLE, 0)
		CONTROL_LTEXT(_T("[0409]This software may be used freely for any legal purposes, including commercial applications. Installation package must NOT be redistributed without authors' permission.[0405]Aplikaci lze zdarma pouvat k libovolnm zkonnm elm, vetn komernch aplikac. Instalan balek NELZE it bez povolen autor."), IDC_LICENSE, 141, 77, 134, 40, WS_VISIBLE, 0)
	END_CONTROLS_MAP()

	BEGIN_MSG_MAP(CAboutDlg)
		CHAIN_MSG_MAP(CContextHelpDlg<CAboutDlg>)
		MESSAGE_HANDLER(WM_CTLCOLORDLG, OnCtlColorDlg)
		MESSAGE_HANDLER(WM_CTLCOLORSTATIC, OnCtlColorStatic)
		MESSAGE_HANDLER(WM_CTLCOLORBTN, OnCtlColorDlg)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		COMMAND_HANDLER(IDOK, BN_CLICKED, OnClickedOK)
		COMMAND_HANDLER(IDCANCEL, BN_CLICKED, OnClickedCancel)
		COMMAND_HANDLER(IDC_COPYRIGHTS, BN_CLICKED, OnClickedHelp)
	END_MSG_MAP()

	BEGIN_CTXHELP_MAP(CAboutDlg)
		//CTXHELP_CONTROL_RESOURCE(IDOK, IDS_HELP_IDOK)
		//CTXHELP_CONTROL_RESOURCE(IDCANCEL, IDS_HELP_IDCANCEL)
	END_CTXHELP_MAP()


	LRESULT OnInitDialog(UINT a_uMsg, WPARAM a_wParam, LPARAM a_lParam, BOOL& a_bHandled)
	{
		CenterWindow();
		m_wndLink.SubclassWindow(GetDlgItem(IDC_HOMEPAGELINK));
		m_wndLink.SetHyperLink(HOMEPAGE_LINK(LANGIDFROMLCID(m_tLocaleID)));
		m_wndPurchase.SubclassWindow(GetDlgItem(IDC_DONATE));
		m_wndPurchase.SetHyperLink(DONATE_LINK(LANGIDFROMLCID(m_tLocaleID)));
		return TRUE;
	}
	LRESULT OnClickedOK(WORD a_wNotifyCode, WORD a_wID, HWND a_hWndCtl, BOOL& a_bHandled)
	{
		EndDialog(a_wID);
		return 0;
	}
	LRESULT OnClickedCancel(WORD a_wNotifyCode, WORD a_wID, HWND a_hWndCtl, BOOL& a_bHandled)
	{
		EndDialog(a_wID);
		return 0;
	}
	LRESULT OnCtlColorDlg(UINT a_uMsg, WPARAM a_wParam, LPARAM a_lParam, BOOL& a_bHandled)
	{
		return (LRESULT)m_hBrush;
	}
	LRESULT OnCtlColorStatic(UINT a_uMsg, WPARAM a_wParam, LPARAM a_lParam, BOOL& a_bHandled)
	{
		SetBkColor((HDC)a_wParam, 0xffffff);
		return (LRESULT)m_hBrush;
	}

	IApplicationInfo* M_AppInfo() const { return m_pApplicationInfo; }

private:
	CHyperLink m_wndLink;
	CHyperLink m_wndPurchase;
	HBRUSH m_hBrush;
	CComPtr<IApplicationInfo> m_pApplicationInfo;
};

HRESULT AppAboutBox(RWHWND a_hWndParent, LCID a_tLocaleID, IApplicationInfo* a_pAI)
{
	CAboutDlg cDlg(a_tLocaleID, a_pAI);
	cDlg.DoModal(reinterpret_cast<HWND>(a_hWndParent));
	return S_OK;
}

#include <ApplicationInfoImpl.h>
#include <RWApplication.inl>

class CDummyAtlModule : public CAtlModule
{
public:
	HRESULT AddCommonRGSReplacements(IRegistrarBase*) throw() { return S_OK; }
};

int APIENTRY _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	hInst = hInstance; // Store instance handle in our global variable
	CDummyAtlModule cModule;

	static const WORD wCode = 0;
	return MainProc(lpCmdLine, NULL, 0, GUID_NULL, ELMDonate, &wCode);
}
