// StorageFilterWindowResource.h : Declaration of the CStorageFilterWindowResource

#pragma once
#include "resource.h"       // main symbols
#include "RWStorage.h"

#include <Win32LangEx.h>


// CStorageFilterWindowResource

class ATL_NO_VTABLE CStorageFilterWindowResource : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public Win32LangEx::CLangDialogImpl<CStorageFilterWindowResource>,
	public CDialogResize<CStorageFilterWindowResource>,
	public CChildWindowImpl<CStorageFilterWindowResource, IStorageFilterWindow>
{
public:
	CStorageFilterWindowResource()
	{
	}

	HRESULT Init(LPCOLESTR a_pszInitial, HWND a_hWnd, LCID a_tLocaleID);

	enum {IDD = IDD_FILTERWINDOWRESOURCE};

	BEGIN_COM_MAP(CStorageFilterWindowResource)
		COM_INTERFACE_ENTRY(IStorageFilterWindow)
	END_COM_MAP()

	BEGIN_MSG_MAP(CStorageFilterWindowResource)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		COMMAND_ID_HANDLER(IDOK, OnOK)
		COMMAND_ID_HANDLER(IDCANCEL, OnCancel)
		CHAIN_MSG_MAP(CDialogResize<CStorageFilterWindowResource>)
	END_MSG_MAP()

	BEGIN_DLGRESIZE_MAP(CStorageFilterWindowResource)
		DLGRESIZE_CONTROL(IDC_FWRES_FILENAME, DLSZ_SIZE_X)
		BEGIN_DLGRESIZE_GROUP()
			DLGRESIZE_CONTROL(IDC_FWRES_TYPE, DLSZ_SIZE_X | DLSZ_SIZE_Y)
			DLGRESIZE_CONTROL(IDC_FWRES_ID, DLSZ_SIZE_X | DLSZ_SIZE_Y)
		END_DLGRESIZE_GROUP()
		BEGIN_DLGRESIZE_GROUP()
			DLGRESIZE_CONTROL(IDC_FWRES_TYPE_TEXT, DLSZ_SIZE_X)
			DLGRESIZE_CONTROL(IDC_FWRES_ID_TEXT, DLSZ_SIZE_X)
		END_DLGRESIZE_GROUP()
	END_DLGRESIZE_MAP()

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
	}

	// IStorageFilterWindow methods
public:
	STDMETHOD(FilterCreate)(IStorageFilter** a_ppFilter);
	STDMETHOD(FiltersCreate)(IEnumUnknowns** a_ppFilters);
	STDMETHOD(DocTypesEnum)(IEnumUnknowns** a_pFormatFilters) { return E_NOTIMPL; }
	STDMETHOD(DocTypeGet)(IDocumentType** a_pFormatFilter) { return E_NOTIMPL; }
	STDMETHOD(DocTypeSet)(IDocumentType* a_pFormatFilter) { return E_NOTIMPL; }
	STDMETHOD(NavigationCommands)(IEnumUnknowns** a_ppCommands) { return E_NOTIMPL; }
	STDMETHOD(OnIdle)() { return S_FALSE; }

	// handlers
public:
	LRESULT OnInitDialog(UINT a_uMsg, WPARAM a_wParam, LPARAM a_lParam, BOOL& a_bHandled);
	LRESULT OnOK(WORD a_wNotifyCode, WORD a_wID, HWND a_hWndCtl, BOOL& a_bHandled);
	LRESULT OnCancel(WORD a_wNotifyCode, WORD a_wID, HWND a_hWndCtl, BOOL& a_bHandled);
	virtual void OnFinalMessage(HWND a_hWnd);

private:
};

