
#pragma once


class ATL_NO_VTABLE CHeadLight : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public ISceneSegment
{
public:
	CHeadLight()
	{
	}

BEGIN_COM_MAP(CHeadLight)
	COM_INTERFACE_ENTRY(ISceneSegment)
END_COM_MAP()


	// ISceneSegment methods
public:
	STDMETHOD(ConfigCreate)(IConfig** UNREF(a_ppConfig))
	{
		return E_NOTIMPL;
	}
	STDMETHOD(ProcessOccluders)(ISceneAssistant* UNREF(a_pAssist), IOcclusionBuilder* UNREF(a_pOcclusion), TMatrix4x4f const* UNREF(a_ptModelView), IConfig* UNREF(a_pConfig))
	{
		return E_NOTIMPL;
	}
	STDMETHOD(ProcessLights)(ISceneAssistant* UNREF(a_pAssist), ILightingBuilder* a_pLighting, TMatrix4x4f const* UNREF(a_ptModelView), IConfig* UNREF(a_pConfig))
	{
		static TAmbientLight const tLightA =
		{
			0.2f, 0.2f, 0.2f,
			//1.0f, 1.0f, 1.0f,
			0.0f, 0.0f, 0.0f,
			100.0f
		};
		a_pLighting->AmbientLightAdd(FALSE, &tLightA);
		static TDirectionalLight const tLight =
		{
			1.0f, 1.0f, 1.0f,
			-1.0f, 1.0f, 3.0f,
			0.0f, 0.0f, 0.0f,
			100.0f
		};
		return a_pLighting->DirectionalLightAdd(FALSE, &tLight);
	}
	STDMETHOD(ProcessGeometry)(ISceneAssistant* UNREF(a_pAssist), ISceneBuilder* UNREF(a_pScene), TMatrix4x4f const* UNREF(a_ptModelView), IConfig* UNREF(a_pConfig))
	{
		return E_NOTIMPL;
	}
	STDMETHOD(ObserverIns)(ISegmentObserver* UNREF(a_pObserver), TCookie UNREF(a_tCookie))
	{
		return E_NOTIMPL;
	}
	STDMETHOD(ObserverDel)(ISegmentObserver* UNREF(a_pObserver), TCookie UNREF(a_tCookie))
	{
		return E_NOTIMPL;
	}
	STDMETHOD(BoundingBox)(TMatrix4x4f const* UNREF(a_ptTransform), IConfig* UNREF(a_pConfig), float* UNREF(a_pXRange), float* UNREF(a_pYRange), float* UNREF(a_pZRange))
	{
		return S_OK;
	}
};

