
#include "../RWStorage/RWStorageSqlite/RWStorageSqlite.h"

const int MAX_SHARED = 8192;
#pragma section("RWDesignerShared",read,write,shared)
__declspec(allocate("RWDesignerShared")) TCHAR g_szShared[MAX_SHARED] = _T("");


int MainProc(LPTSTR lpCmdLine, CLSID const* a_pStartPages, int a_nStartPages, CLSID const& a_tDefaultStartPage, ELicensingMode a_eLicensingMode = ELMDonate, WORD const* a_aCodes = NULL, UINT a_uDefaultsID = IDR_DEFAULTS, UINT a_uLibraryID = 0)
{
	try
	{
		ULONG nCmdLine = 0;
		if (lpCmdLine)
		{
			if (lpCmdLine[0] == _T('\"'))
			{
				++lpCmdLine;
				while (lpCmdLine[nCmdLine] && lpCmdLine[nCmdLine] != _T('\"'))
					++nCmdLine;
			}
			else
			{
				nCmdLine = _tcslen(lpCmdLine);
			}
		}
		TCHAR szExeName[MAX_PATH] = _T("");
		GetModuleFileName(hInst, szExeName, MAX_PATH);
		TCHAR szSmphrName[MAX_PATH+5] = _T("Smphr");
		GetShortPathName(szExeName, szSmphrName+5, MAX_PATH);
		for (int i=0; i<(MAX_PATH+5) && szSmphrName[i] != _T('\0'); i++)
		{
			if (szSmphrName[i] == _T('\\')) szSmphrName[i] = _T('-');
			if (szSmphrName[i] == _T(':')) szSmphrName[i] = _T('_');
		}
		_tcsupr(szSmphrName+5);
		TCHAR szEventName[MAX_PATH] = _T("Event");
		_tcscpy(szEventName+5, szSmphrName+5);

		HANDLE hSmphr = CreateSemaphore(NULL, 0, 1, szSmphrName);
		if (!hSmphr) return 1;

		if (GetLastError() == ERROR_ALREADY_EXISTS)
		{
			if (WaitForSingleObject(hSmphr, INFINITE) != WAIT_OBJECT_0)
			{
				CloseHandle(hSmphr);
				return 1;
			}
			HANDLE hEvent = OpenEvent(EVENT_ALL_ACCESS, FALSE, szEventName);
			if (hEvent == 0)
			{
				ReleaseSemaphore(hSmphr, 1, NULL);
				CloseHandle(hSmphr);
				return 1;
			}
			if (lpCmdLine)
			{
				if (_tcscmp(lpCmdLine, _T("/manage")) == 0 || _tcscmp(lpCmdLine, _T("/reset")) == 0)
				{
					MessageBox(NULL, _T("Please close all application windows and then try again."), APP_MSGBOX_CAPTION, MB_OK|MB_ICONERROR|MB_TOPMOST);
				}
				else
				{
					_tcsncpy(g_szShared, lpCmdLine, min(MAX_SHARED-1, nCmdLine));
					g_szShared[min(MAX_SHARED-1, nCmdLine)] = _T('\0');
					AllowSetForegroundWindow(ASFW_ANY);
					SetEvent(hEvent);
				}
			}
			else 
			{
				g_szShared[0] = 0;
				SetEvent(hEvent);
			}
			CloseHandle(hEvent);
			CloseHandle(hSmphr);
			return 0;
		}
		HANDLE hEvent = CreateEvent(NULL, FALSE, FALSE, szEventName);
		if(!hEvent)
		{
			CloseHandle(hSmphr);
			return 1;
		}
		ReleaseSemaphore(hSmphr, 1, NULL);

		if (FAILED(OleInitialize(NULL)))
			return 1;

		g_sAppInfo.Init();
		AddClass(&GetClassObjectAppInfo, __uuidof(ApplicationInfo), 0, NULL);

		// Windows 7 app ID
		HMODULE hShell32 = NULL;
		//if (XPGUI::IsWin7())
		//{
		//	HMODULE hShell32 = LoadLibrary(_T("shell32.dll"));
		//	if (hShell32)
		//	{
		//		HRESULT (STDAPICALLTYPE *pfnSetAppID)(PCWSTR) = (HRESULT (STDAPICALLTYPE *)(PCWSTR))GetProcAddress(hShell32, "SetCurrentProcessExplicitAppUserModelID");
		//		if (pfnSetAppID)
		//		{
		//			OLECHAR szAppID[64] = L"";
		//			ULONG nVer = 0;
		//			g_sAppInfo.Version(&nVer);
		//			swprintf(szAppID, RWAPPID L"_%i.%i.%i", (nVer>>16)&0xffff, (nVer>>8)&0xff, nVer&0xff);
		//			(*pfnSetAppID)(szAppID);
		//		}
		//	}
		//}

		bool bForceReset = false;
		if (_tcscmp(lpCmdLine, _T("/manage")) == 0 || _tcscmp(lpCmdLine, _T("/reset")) == 0 || (GetAsyncKeyState(VK_SHIFT)&GetAsyncKeyState(VK_CONTROL)&0x8000))
		{
			bForceReset = IDYES == MessageBox(NULL, _T("Delete current configuration and revert to initial state of the application?"), APP_MSGBOX_CAPTION, MB_YESNO|MB_ICONQUESTION|MB_TOPMOST);
		}

		// show splash
		unsigned idSplashThread;
		HANDLE hSplash = (HANDLE)_beginthreadex(NULL, 0, Splash, NULL, 0, &idSplashThread);
		SetThreadPriority(hSplash, THREAD_PRIORITY_ABOVE_NORMAL);

		CAutoVectorPtr<BYTE> pCfgData;
		ULONG nCfgLen = 0;
		OLECHAR szConfigPath[MAX_PATH];
		{
			// load configuration
			swprintf(szConfigPath, L"%s\\Config." _T(RWVER0409_PRODUCTVERSION), g_sAppInfo.M_UserFolder());
			HANDLE h = CreateFile(szConfigPath, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN, NULL);
			if (h != INVALID_HANDLE_VALUE)
			{
				DWORD dw;
				DWORD dwLen = GetFileSize(h, &dw);
				if (dwLen)
				{
					pCfgData.Attach(new BYTE[dwLen]);
					dw = 0;
					if (ReadFile(h, pCfgData.m_p, dwLen, &dw, NULL) && dwLen == dw)
					{
						nCfgLen = dwLen;
					}
				}
				CloseHandle(h);
			}
		}

		{
			// load plug-ins
			OLECHAR szMaskCust[MAX_PATH];
			swprintf(szMaskCust, L"%s\\PlugIns", g_sAppInfo.M_UserFolder());
			// delete updates and plug-ins if configuration is not present or being reset
			ProcessPlugInUpdates(szMaskCust, g_sAppInfo.M_AppFolder(), nCfgLen == 0 || bForceReset);
			OLECHAR szMaskApp[MAX_PATH];
			swprintf(szMaskApp, L"%s\\RW*.dll", g_sAppInfo.M_AppFolder());
			wcscat(szMaskCust, L"\\*.dll");
			OLECHAR const* aSearchMasks[] = {szMaskApp, szMaskCust, NULL};
			InitializePlugIns(aSearchMasks);
		}

		{
			// load or reset configuration
			CComPtr<IConfigInMemory> pCfgSrc;
			RWCoCreateInstance(pCfgSrc, __uuidof(ConfigInMemory));
			bool bConfigRead = false;
			if (!bForceReset && nCfgLen)
			{
				bConfigRead = SUCCEEDED(pCfgSrc->DataBlockSet(nCfgLen, pCfgData.m_p));
			}
			if (!bConfigRead)
			{
				HRSRC hLayouts = FindResource(hInst, MAKEINTRESOURCE(a_uDefaultsID), _T("RT_CONFIG"));
				HGLOBAL hMem = LoadResource(hInst, hLayouts);
				DWORD nMemSize = SizeofResource(hInst, hLayouts);
				pCfgSrc->DeleteItems(NULL);
				pCfgSrc->DataBlockSet(nMemSize, static_cast<BYTE const*>(LockResource(hMem)));
			}
			pCfgData.Free();
			nCfgLen = 0;

			// initialize library if there is one
			if (a_uLibraryID)
			{
				// save the default library
				HRSRC hLayouts = FindResource(hInst, MAKEINTRESOURCE(a_uLibraryID), _T("RT_LIBRARY"));
				HGLOBAL hMem = LoadResource(hInst, hLayouts);
				DWORD nMemSize = SizeofResource(hInst, hLayouts);
				CComPtr<IStorageFactorySQLite> pSqlite;
				RWCoCreateInstance(pSqlite, __uuidof(StorageFactorySQLite));
				pSqlite->MergeDefaults(nMemSize, reinterpret_cast<BYTE const*>(LockResource(hMem)), 1, NULL);
/*				OLECHAR szLibPath[MAX_PATH];
				swprintf(szLibPath, L"%s\\default.rwdb", g_sAppInfo.M_UserFolder());
				COLE2CT strLibPath(szLibPath);
				HANDLE h = CreateFile(strLibPath, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN, NULL);
				if (h == INVALID_HANDLE_VALUE)
				{
					// check if there is a previous version of the library
					OLECHAR szOldLibPath[MAX_PATH];
					swprintf(szOldLibPath, L"%s.rwdb", g_sAppInfo.M_UserFolder());
					COLE2CT strOldLibPath(szOldLibPath);
					HANDLE hOld = CreateFile(strOldLibPath, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN, NULL);
					if (hOld != INVALID_HANDLE_VALUE)
					{
						ULONG nSize = GetFileSize(hOld, NULL);
						if (nSize)
						{
							h = CreateFile(strLibPath, GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_NEW, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN, NULL);
							if (h != INVALID_HANDLE_VALUE)
							{
								CAutoVectorPtr<BYTE> cBuffer(new BYTE[0x10000]);
								for (ULONG nOff = 0; nOff < nSize; nOff += 0x10000)
								{
									DWORD dw;
									ReadFile(hOld, cBuffer.m_p, min(0x10000, nSize-nOff), &dw, NULL);
									WriteFile(h, cBuffer.m_p, dw, &dw, NULL);
								}
								CloseHandle(h);
							}
							CloseHandle(hOld);
						}
						else
						{
							CloseHandle(hOld);
							hOld = INVALID_HANDLE_VALUE;
						}
					}

					if (hOld == INVALID_HANDLE_VALUE)
					{
						// save the default library
						HRSRC hLayouts = FindResource(hInst, MAKEINTRESOURCE(a_uLibraryID), _T("RT_LIBRARY"));
						HGLOBAL hMem = LoadResource(hInst, hLayouts);
						DWORD nMemSize = SizeofResource(hInst, hLayouts);
						h = CreateFile(strLibPath, GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_NEW, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN, NULL);
						if (h != INVALID_HANDLE_VALUE)
						{
							DWORD dw;
							WriteFile(h, LockResource(hMem), nMemSize, &dw, NULL);
							CloseHandle(h);
						}
					}
				}
				else
				{
					CloseHandle(h);
				}
*/			}

			// initialize translation service
			CComPtr<ITranslatorManager> pTrMan;
			RWCoCreateInstance(pTrMan, __uuidof(Translator));
			if (pTrMan)
				pTrMan->Initialize(&g_sAppInfo);

			CComPtr<IDesignerCore> pDesigner;
			RWCoCreateInstance(pDesigner, __uuidof(DesignerCore));
			// init application defaults
			pDesigner->Initialize(pCfgSrc, &g_sAppInfo, a_nStartPages, a_pStartPages, a_tDefaultStartPage, NULL, EMTDefault);

			RWHWND hMainWnd = 0;
			if (lpCmdLine[0] == _T('\0') || bForceReset)
				pDesigner->NewWindowPage(GUID_NULL, &hMainWnd);
			else
				pDesigner->NewWindowPath(CComBSTR(nCmdLine, lpCmdLine), &hMainWnd);
			PostThreadMessage(idSplashThread, WM_QUIT, 0, 0);
			CloseHandle(hSplash);

			if (!g_sAppInfo.CheckActivation())
				g_sAppInfo.LicenseBox(hMainWnd, GetThreadLocale());

			while (true)
			{
				ULONG nWaitResult = WAIT_TIMEOUT;
				if (FAILED(pDesigner->MessagePump(1, &hEvent, &nWaitResult)) || nWaitResult != WAIT_OBJECT_0)
					break;
				TCHAR szTemp[MAX_SHARED];
				_tcsncpy(szTemp, g_szShared, MAX_SHARED);
				ReleaseSemaphore(hSmphr, 1, NULL);
				if(0 == _tcscmp(szTemp, _T("exit"))) break;
				RWHWND h;
				if (szTemp[0] == _T('\0'))
					pDesigner->NewWindowPage(GUID_NULL, &h);
				else
					pDesigner->NewWindowPath(CComBSTR(szTemp), &h);
			}
			pDesigner = NULL;
			if (pTrMan)
			{
				pTrMan->Finalize(TRUE);
				pTrMan = NULL;
			}
			ULONG dwLen = 0;
			pCfgSrc->DataBlockGetSize(&dwLen);
			if (dwLen)
			{
				CAutoVectorPtr<BYTE> pData(new BYTE[dwLen]);
				if (SUCCEEDED(pCfgSrc->DataBlockGet(dwLen, pData.m_p)))
				{
					TCHAR szConfigPath2[MAX_PATH];
					_tcscpy(szConfigPath2, szConfigPath);
					_tcscat(szConfigPath2, _T(".tmp"));
					HANDLE h = CreateFile(szConfigPath2, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN, NULL);
					if (h != INVALID_HANDLE_VALUE)
					{
						DWORD dw = 0;
						WriteFile(h, pData.m_p, dwLen, &dw, NULL);
						CloseHandle(h);
						if (dwLen == dw)
						{
							DeleteFile(szConfigPath);
							MoveFile(szConfigPath2, szConfigPath);
						}
						else
						{
							DeleteFile(szConfigPath2);
						}
					}
				}
			}
			CloseHandle(hSmphr);
			CloseHandle(hEvent);
		}

		ReleasePlugIns();

		OleUninitialize();

		if (hShell32)
			FreeLibrary(hShell32);
	}
	catch (...)
	{
		MessageBox(NULL, _T("A critical error occured in the application. Try restarting Windows, reinstallting the application, or contact the authors at support@rw-designer.com."), APP_MSGBOX_CAPTION, MB_OK|MB_ICONERROR|MB_TOPMOST);
	}

	return 0;
}
